<template>
  <section class="c-role-roles c-form-section">
    <Title
      :text="data['your_current_&_historic_roles_title']"
      type="secondary"
    />

    <section class="c-roles-list">
      <article
        v-for="item in fields.currentHistoricRolesList.$each.$iter"
        :key="item.id.$model"
        class="c-roles-list__item"
      >
        <!--TODO Label: fetch-->
        <FormDatePicker
          label="From"
          :id="`date-from-${item.id.$model}`"
          v-model="item.from.$model"
          :error="formErrorMessagesHandler(item.from)"
          class="datepicker"
        />
        <!--TODO Label: fetch-->
        <FormDatePicker
          label="To"
          :id="`date-to-${item.id.$model}`"
          v-model="item.to.$model"
          :error="formErrorMessagesHandler(item.to)"
          class="datepicker"
        />
        <!--TODO Label: fetch-->
        <FormInput
          :id="`current-historic-role-position-${item.id.$model}`"
          v-model.trim="item.position.$model"
          label="Position"
          :error="formErrorMessagesHandler(item.position)"
        />
        <!--TODO Label: fetch-->
        <FormInput
          :id="`current-historic-role-organization-${item.id.$model}`"
          v-model.trim="item.organization.$model"
          label="Organization"
          :error="formErrorMessagesHandler(item.organization)"
        />
        <FormButtonRemove @clicked="removeRoleHandler(item.id.$model)" />
      </article>
    </section>
    <FormAddRole text="Add a role" @clicked="addRoleHandler()" />
    <div
      v-if="
        fields.currentHistoricRolesList.$error &&
          !fields.currentHistoricRolesList.$model.length
      "
    >
      <ErrorMessage
        v-if="fields.currentHistoricRolesList.minLength"
        :text="formErrorMessagesHandler(fields.currentHistoricRolesList)"
        align="center"
      />
    </div>

    <div class="c-roles-headlines">
      <FormInput
        id="currentHistoricRolesHeadlines"
        v-model.trim="fields.currentHistoricRolesHeadlines.$model"
        label="Headline role(s)"
        :error="formErrorMessagesHandler(fields.currentHistoricRolesHeadlines)"
      />
      <Paragraph
        v-if="!isPreview"
        class="c-roles-headlines__note"
        text="Your chosen headline will be shown against your name."
      />
    </div>
  </section>
</template>

<script>
import { uuid } from "vue-uuid";
import { mapMutations } from "vuex";
import Title from "../ui/Title";
import { errorMixins } from "../mixins/formErrors";
import FormInput from "../ui/form/FormInput";
import FormAddRole from "../ui/form/FormAddRole";
import ErrorMessage from "../ui/ErrorMessage";
import FormButtonRemove from "../ui/form/FormButtonRemove";
import FormDatePicker from "../ui/form/FormDatePicker";
import Paragraph from "../ui/Paragraph";
import { isPreviewMixin } from "../mixins/isPreview";

export default {
  name: "RoleCurrentHistoricRoles",
  components: {
    Paragraph,
    FormDatePicker,
    FormButtonRemove,
    ErrorMessage,
    FormAddRole,
    FormInput,
    Title
  },
  props: {
    fields: {
      type: Object,
      required: true
    }
  },
  mixins: [errorMixins, isPreviewMixin],
  data: function() {
    return {
      data: this.$store.state.data.data
    };
  },
  methods: {
    ...mapMutations(["addRole", "removeRole"]),
    addRoleHandler() {
      this.$store.commit("addRole", {
        field: "currentHistoricRolesList",
        data: {
          id: uuid.v1(),
          from: "",
          to: "",
          position: "",
          organization: ""
        }
      });
    },
    removeRoleHandler(id) {
      this.$store.commit("removeRole", {
        field: "currentHistoricRolesList",
        id
      });
    }
  }
};
</script>

<style lang="scss">
.c-role-roles {
}
.c-roles-list {
  &__item {
    margin-bottom: 4rem;
    @include breakpoint(overPhone) {
      display: flex;
      margin-bottom: 3rem;
    }

    &:last-of-type {
      @include breakpoint(overPhone) {
        margin-bottom: 5rem;
      }
    }

    .c-form-control {
      @include breakpoint(overPhone) {
        margin-right: 1rem;
        width: 15.3rem;
        margin-bottom: 0;
      }

      &.datepicker {
        @include breakpoint(overPhone) {
          width: 9rem;
        }
      }
    }

    .c-remove {
      @include breakpoint(overPhone) {
        margin: 2.6rem 0 0;
      }
    }
  }
}
.c-roles-headlines {
  margin-top: 5rem;
  @include breakpoint(overPhone) {
    margin-top: 8rem;
  }

  &__note {
    margin-top: 2rem;
    @include breakpoint(overPhone) {
      max-width: 50%;
    }
  }

  .c-form-control {
    @include breakpoint(overPhone) {
      max-width: 28rem;
    }
  }
}
</style>
